VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1230
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6645
   LinkTopic       =   "Form1"
   ScaleHeight     =   1230
   ScaleWidth      =   6645
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDirectory 
      Height          =   285
      Left            =   960
      TabIndex        =   0
      Text            =   "C:\temp\test"
      Top             =   120
      Width           =   5535
   End
   Begin VB.CommandButton cmdConvertEmails 
      Caption         =   "Convert Emails"
      Height          =   495
      Left            =   2760
      TabIndex        =   1
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Directory"
      Height          =   255
      Index           =   3
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Note: This application needs a reference to the
' Microsoft Word object library. This example uses
' Word version 9.0. You should change it for your system.
Option Explicit
' Convert a .eml file into a Word file.
Private Sub EmlToWord(ByVal word_app As Word.Application, ByVal file_name As String)
Dim txt As String
Dim lines() As String
Dim line_num As Integer
Dim pos As Integer
Dim field_name As String
Dim field_value As String
Dim field_to As String
Dim field_from As String
Dim field_date As String
Dim field_subject As String
Dim field_return_path As String
Dim field_body As String
Dim i As Integer
Dim word_doc As Word.Document
Dim rng As Word.Range

    ' Get the eml file.
    txt = GetFileContents(file_name)

    ' Process the header.
    txt = Replace$(txt, vbCrLf, vbCr)
    txt = Replace$(txt, vbLf, vbCr)
    lines = Split(txt, vbCr)
    line_num = LBound(lines)
    Do
        ' Get the next field's name and value.
        GetField lines, line_num, field_name, field_value

        Select Case LCase$(field_name)
            Case "to"
                field_to = field_value
            Case "from"
                field_from = field_value
            Case "subject"
                field_subject = field_value
            Case "date"
                field_date = field_value
            Case "return-path"
                field_return_path = field_value
            Case ""
                Exit Do
            Case Else
                ' Ignore everything else.
        End Select
    Loop

    ' Concatenate the rest of the lines.
    field_body = ""
    For i = line_num To UBound(lines)
        field_body = field_body & lines(i) & vbCrLf
    Next i

    ' Put the results in a new Word document.
    Set word_doc = word_app.Documents.Add(DocumentType:=wdNewBlankDocument, Visible:=False)
    word_doc.Activate
    Set rng = word_doc.Range()
    rng.Collapse wdCollapseStart

    rng.InsertAfter "To:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_to & vbCrLf
    rng.Collapse wdCollapseEnd

    rng.InsertAfter "From:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_from & vbCrLf
    rng.Collapse wdCollapseEnd

    rng.InsertAfter "Return-Path:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_return_path & vbCrLf
    rng.Collapse wdCollapseEnd

    rng.InsertAfter "Date:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_date & vbCrLf
    rng.Collapse wdCollapseEnd

    rng.InsertAfter "Subject:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_subject & vbCrLf
    rng.Collapse wdCollapseEnd

    rng.InsertAfter "Body:" & vbCrLf
    rng.Style = word_doc.Styles("Heading 1")
    rng.Collapse wdCollapseEnd
    rng.InsertAfter field_body & vbCrLf
    rng.Collapse wdCollapseEnd

    ' Save the file.
    file_name = Replace$(file_name, ".eml", ".doc")
    word_doc.SaveAs file_name
    word_doc.Close
End Sub

' Get the next field's name and value.
' Return field_name = "" if there are no more fields.
Private Sub GetField(lines() As String, ByRef line_num As Integer, ByRef field_name As String, ByRef field_value As String)
Dim pos As Integer

    field_name = ""
    field_value = ""

    ' See if this is the end of the header.
    If Len(Trim$(lines(line_num))) = 0 Then Exit Sub

    ' Find the end of the field name.
    pos = InStr(lines(line_num), ":")
    If (pos = 0) Or (Left$(lines(line_num), 1) = " ") Then
        ' The line doesn't start with a field name.
        field_name = "?"
        field_value = lines(line_num)
        line_num = line_num + 1
        Exit Sub
    End If

    ' Get the field name.
    field_name = Left$(lines(line_num), pos - 1)

    ' Get the beginning of the field value.
    field_value = Mid$(lines(line_num), pos + 1)
    line_num = line_num + 1

    ' Get the rest of the field value (if there is any).
    Do While line_num <= UBound(lines)
        ' If the line doesn't begin with a space,
        ' that's the end of the field.
        If (Left$(lines(line_num), 1) <> " ") And _
           (Left$(lines(line_num), 1) <> vbTab) _
                Then Exit Do

        ' Get this part of the field.
        field_value = field_value & vbCrLf & lines(line_num)

        line_num = line_num + 1
    Loop
End Sub
' Get the file's contents.
Private Function GetFileContents(ByVal file_name As String) As String
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open file_name For Input As fnum

    ' Grab the file's contents.
    GetFileContents = Input(LOF(fnum), fnum)

    ' Close the file.
    Close fnum
End Function

Private Sub cmdConvertEmails_Click()
Dim word_app As Object 'Word.Application
Dim dir_name As String
Dim file_name As String

    On Error GoTo ExtractError
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Open Word.
    ' Set word_app = New Word.Application
    Set word_app = CreateObject("Word.Application")

    ' Get the directory name.
    dir_name = txtDirectory.Text
    If Right$(dir_name, 1) <> "\" Then dir_name = dir_name & "\"

    ' Get the eml files.
    file_name = Dir$(dir_name & "*.eml")
    Do While Len(file_name) > 0
        ' Process this file.
        Me.Caption = file_name
        DoEvents
        EmlToWord word_app, dir_name & file_name

        ' Get the next file.
        file_name = Dir$()
    Loop

CleanUp:
    On Error Resume Next
    word_app.Quit False
    Set word_app = Nothing

    Screen.MousePointer = vbDefault
    Me.SetFocus
    MsgBox "Done"
    Exit Sub

ExtractError:
    MsgBox Err.Description, vbExclamation, "Extract Error"
    Resume CleanUp
    Exit Sub
End Sub


